package com.ruoyi.workflow.service;

import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.workflow.domain.bo.UserDeployRelationBo;
import com.ruoyi.workflow.domain.vo.UserDeployRelationVo;

import java.util.Collection;
import java.util.List;

/**
 * 用户流程关联Service接口
 *
 * @author ruoyi
 * @date 2024-04-25
 */
public interface IUserDeployRelationService {

    /**
     * 查询用户流程关联
     */
    UserDeployRelationVo queryById(String id);

    /**
     * 查询用户流程关联列表
     */
    TableDataInfo<UserDeployRelationVo> queryPageList(UserDeployRelationBo bo, PageQuery pageQuery);

    /**
     * 查询用户流程关联列表
     */
    List<UserDeployRelationVo> queryList(UserDeployRelationBo bo);

    /**
     * 新增用户流程关联
     */
    Boolean insertByBo(UserDeployRelationBo bo);

    /**
     * 修改用户流程关联
     */
    Boolean updateByBo(UserDeployRelationBo bo);

    /**
     * 校验并批量删除用户流程关联信息
     */
    Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid);
}
